#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Jan 26 13:57:11 2020

@author: keven
"""

import numpy as np

import matplotlib.pyplot as plt


def carre(x):
    #x est un nombre (float ou int)
    #renvoie le carré de x
    return(x**2)
    
def euler(t0,y0,tmax,fonction,n):
    # t0, y0 et tmax (>t0) sont des nombres, 
    # fonction est une fonction numérique
    # n est un entier naturel >1
    # fonction qui renvoie l'approximation de
    # la solution de y'=fonction(y) avec la condition initiale
    # y(t0)=y0 obtenue à l'aide de la méthode d'Euler avec 
    # n points entre les temps t0 et tmax
    
    # Calcul du pas de la disrectisation du temps entre t0 et tmax avec n points
    pas=(tmax-t0)/(n-1)
    
    # on construit l'approximation de y
    y=[y0]
    for i in range(n-1) :
        y.append(y[-1]+pas*fonction(y[-1]))
    
    return(y)
    
    
#####################################################################
    
# POUR TESTER :

def compare(n): 
    #n est un entier naturel >1
    # procédure qui provoque l'affichage des courbes
    # de la solution exacte de y'=y^2 avec y(0)=1/2
    # ainsi que de son approximation obtenu avec Euler
   
    temps_discret=np.linspace(0,1.5,n)    

    y_approx=euler(0,.5,1.5,carre,n)   

    y_exact=1/(2-temps_discret)
    plt.plot(temps_discret,y_approx,'-r',temps_discret,y_exact,'-b')    
    
    
#####################################################################

# ERREUR DE LA METHODE D'EULER

def solution_exacte(x):
    # x est un nombre
    # renvoie l'image de x par x -> 1/(2-x)
    return(1/(2-x))


def erreur():
    # procédure qui calcule l'erreur max commise par la méthode d'Euler
    # pour n points avec n qui varie de 10 à 1000 par pas de 10
    # provoque l'affichage de l'erreur en fonction de n    
    N=range(10,1000,10)
    erreur=[]
    for n in N:
        temps=np.linspace(0,1.5,n)
        exact=[solution_exacte(i) for i in temps]
        approx=euler(0,.5,1.5,carre,n)
        erreur_pour_n=[abs(e-a) for e,a in zip(exact,approx)]
        erreur.append(max(erreur_pour_n))
        
    plt.plot(N,erreur,'-y')
    